Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.4/SlaveView.Designer.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.4/SlaveView.Designer.cs	(revision 5362)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.4/SlaveView.Designer.cs	(revision 5363)
@@ -112,5 +112,5 @@
       this.Controls.Add(this.label1);
       this.Name = "SlaveView";
-      this.Size = new System.Drawing.Size(667, 435);
+      this.Size = new System.Drawing.Size(590, 435);
       this.ResumeLayout(false);
       this.PerformLayout();
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/MenuItems/ConnectionSetupMenuItem.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/MenuItems/ConnectionSetupMenuItem.cs	(revision 5362)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/MenuItems/ConnectionSetupMenuItem.cs	(revision 5363)
@@ -35,5 +35,5 @@
     public override System.Drawing.Image Image {
       get {
-        return HeuristicLab.Common.Resources.VS2008ImageLibrary.NetworkConnections;
+        return HeuristicLab.Common.Resources.VSImageLibrary.NetworkConnections;
       }
     }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJobClient.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJobClient.cs	(revision 5362)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJobClient.cs	(revision 5363)
@@ -23,15 +23,13 @@
 using System.Collections.Generic;
 using System.Drawing;
+using System.IO;
 using System.Linq;
+using HeuristicLab.Clients.Hive.Jobs;
 using HeuristicLab.Collections;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Optimization;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
 using HeuristicLab.Services.Hive.Common.DataTransfer;
-using HeuristicLab.Clients.Hive.Jobs;
-using HeuristicLab.PluginInfrastructure;
-using System.IO;
-using HeuristicLab.PluginInfrastructure.Manager;
 
 namespace HeuristicLab.Clients.Hive {
@@ -44,13 +42,13 @@
       get {
         if (job.Id == Guid.Empty) { // not yet uploaded
-          return HeuristicLab.Common.Resources.VS2008ImageLibrary.Event;
+          return HeuristicLab.Common.Resources.VSImageLibrary.Event;
         } else {
-          if (job.JobState == JobState.Waiting) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutablePrepared;
-          else if (job.JobState == JobState.WaitingForChildJobs) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutablePrepared;
-          else if (job.JobState == JobState.Calculating) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutableStarted;
-          else if (job.JobState == JobState.Aborted) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutableStopped;
-          else if (job.JobState == JobState.Failed) return HeuristicLab.Common.Resources.VS2008ImageLibrary.Error;
-          else if (job.JobState == JobState.Finished) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutableStopped;
-          else return HeuristicLab.Common.Resources.VS2008ImageLibrary.Event;
+          if (job.JobState == JobState.Waiting) return HeuristicLab.Common.Resources.VSImageLibrary.ExecutablePrepared;
+          else if (job.JobState == JobState.WaitingForChildJobs) return HeuristicLab.Common.Resources.VSImageLibrary.ExecutablePrepared;
+          else if (job.JobState == JobState.Calculating) return HeuristicLab.Common.Resources.VSImageLibrary.ExecutableStarted;
+          else if (job.JobState == JobState.Aborted) return HeuristicLab.Common.Resources.VSImageLibrary.ExecutableStopped;
+          else if (job.JobState == JobState.Failed) return HeuristicLab.Common.Resources.VSImageLibrary.Error;
+          else if (job.JobState == JobState.Finished) return HeuristicLab.Common.Resources.VSImageLibrary.ExecutableStopped;
+          else return HeuristicLab.Common.Resources.VSImageLibrary.Event;
         }
       }
@@ -177,7 +175,7 @@
         } else if (OptimizerJob.Optimizer is Optimization.BatchRun) {
           Optimization.BatchRun batchRun = OptimizerJob.OptimizerAsBatchRun;
-          if (batchRun.Algorithm != null) {
+          if (batchRun.Optimizer != null) {
             while (this.childHiveJobs.Count < batchRun.Repetitions) {
-              this.childHiveJobs.Add(new HiveJob(batchRun.Algorithm));
+              this.childHiveJobs.Add(new HiveJob(batchRun.Optimizer));
             }
             while (this.childHiveJobs.Count > batchRun.Repetitions) {
@@ -200,5 +198,5 @@
           Optimization.BatchRun batchRun = OptimizerJob.OptimizerAsBatchRun;
           batchRun.RepetitionsChanged += new EventHandler(batchRun_RepetitionsChanged);
-          batchRun.AlgorithmChanged += new EventHandler(batchRun_AlgorithmChanged);
+          batchRun.OptimizerChanged += new EventHandler(batchRun_OptimizerChanged);
         }
         OptimizerJob.ComputeInParallelChanged += new EventHandler(OptimizerJob_ComputeInParallelChanged);
@@ -217,5 +215,5 @@
           Optimization.BatchRun batchRun = OptimizerJob.OptimizerAsBatchRun;
           batchRun.RepetitionsChanged -= new EventHandler(batchRun_RepetitionsChanged);
-          batchRun.AlgorithmChanged -= new EventHandler(batchRun_AlgorithmChanged);
+          batchRun.OptimizerChanged -= new EventHandler(batchRun_OptimizerChanged);
         }
         OptimizerJob.ComputeInParallelChanged -= new EventHandler(OptimizerJob_ComputeInParallelChanged);
@@ -224,5 +222,5 @@
     }
 
-    void batchRun_AlgorithmChanged(object sender, EventArgs e) {
+    void batchRun_OptimizerChanged(object sender, EventArgs e) {
       if (syncJobsWithOptimizers) {
         this.childHiveJobs.Clear();
@@ -308,5 +306,5 @@
     ///   replace the child-optimizer in the experiment
     /// if this.Optimizer is BatchRun
-    ///   add the runs from the optimizerJob to the batchrun and replace the algorithm
+    ///   add the runs from the optimizerJob to the batchrun and replace the Optimizer
     /// </summary>
     public void UpdateChildOptimizer(OptimizerJob optimizerJob, Guid childJobId) {
@@ -341,10 +339,10 @@
 
     /// <summary>
-    /// Adds the runs from the optimizerJob to the batchrun and replaces the algorithm 
+    /// Adds the runs from the optimizerJob to the batchrun and replaces the Optimizer 
     /// Sideeffect: the optimizerJob.Optimizer will be prepared (scopes are deleted and executionstate will be reset)
     /// </summary>
     private void UpdateOptimizerInBatchRun(BatchRun batchRun, OptimizerJob optimizerJob) {
-      if (batchRun.Algorithm == null) {
-        batchRun.Algorithm = (IAlgorithm)optimizerJob.Optimizer; // only set the first optimizer as algorithm. if every time the Algorithm would be set, the runs would be cleared each time
+      if (batchRun.Optimizer == null) {
+        batchRun.Optimizer = (IOptimizer)optimizerJob.Optimizer; // only set the first optimizer as Optimizer. if every time the Optimizer would be set, the runs would be cleared each time
       }
       foreach (IRun run in optimizerJob.Optimizer.Runs) {
@@ -438,5 +436,5 @@
       } else if (withoutChildOptimizers && this.OptimizerJob.Optimizer is Optimization.BatchRun) {
         OptimizerJob clonedJob = (OptimizerJob)this.OptimizerJob.Clone();
-        clonedJob.OptimizerAsBatchRun.Algorithm = null;
+        clonedJob.OptimizerAsBatchRun.Optimizer = null;
         jobByteArray = PersistenceUtil.Serialize(clonedJob);
       } else if (this.OptimizerJob.Optimizer is IAlgorithm) {
@@ -462,5 +460,5 @@
     private void UpdateRequiredPlugins() {
       List<Guid> pluginList = new List<Guid>();
-      
+
       IEnumerable<IPluginDescription> neededPlugins = ApplicationManager.Manager.Plugins; //HivePluginInfoDto.FindPluginsNeeded(optimizerJob.GetType());
       using (var service = ServiceLocator.Instance.GetService()) {
@@ -481,5 +479,5 @@
             }
             pluginList.Add(service.Obj.AddPlugin(p, pluginDatas));
-          }          
+          }
         }
       }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/Jobs/OptimizerJob.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/Jobs/OptimizerJob.cs	(revision 5362)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/Jobs/OptimizerJob.cs	(revision 5363)
@@ -24,7 +24,7 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Hive;
 using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Hive;
 
 namespace HeuristicLab.Clients.Hive.Jobs {
@@ -85,5 +85,6 @@
       this.log = new Log();
     }
-    public OptimizerJob(IOptimizer optimizer) : this() {
+    public OptimizerJob(IOptimizer optimizer)
+      : this() {
       this.Optimizer = optimizer;
 
@@ -98,5 +99,6 @@
     [StorableConstructor]
     protected OptimizerJob(bool deserializing) { }
-    protected OptimizerJob(OptimizerJob original, Cloner cloner) : base(original, cloner) {
+    protected OptimizerJob(OptimizerJob original, Cloner cloner)
+      : base(original, cloner) {
       this.Optimizer = cloner.Clone(original.Optimizer);
       this.log = cloner.Clone(original.Log);
@@ -145,5 +147,5 @@
     public virtual void Start() {
       if ((optimizer is Optimization.Experiment && OptimizerAsExperiment.Optimizers.Count == 0) || // experiment would not fire OnStopped if it has 0 optimizers
-          (optimizer is Optimization.BatchRun && OptimizerAsBatchRun.Algorithm == null)) { // batchrun would not fire OnStopped if algorithm == null
+          (optimizer is Optimization.BatchRun && OptimizerAsBatchRun.Optimizer == null)) { // batchrun would not fire OnStopped if algorithm == null
         OnJobStopped();
       } else {
@@ -281,5 +283,5 @@
     protected virtual void OnDescriptionChanged() {
       var handler = DescriptionChanged;
-      if(handler != null) handler(this, EventArgs.Empty);
+      if (handler != null) handler(this, EventArgs.Empty);
     }
     public event EventHandler ItemImageChanged;
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/HeuristicLab.Services.Hive-3.4.csproj
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/HeuristicLab.Services.Hive-3.4.csproj	(revision 5362)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/HeuristicLab.Services.Hive-3.4.csproj	(revision 5363)
@@ -109,5 +109,7 @@
   </ItemGroup>
   <ItemGroup>
-    <None Include="app.config" />
+    <None Include="app.config">
+      <SubType>Designer</SubType>
+    </None>
     <None Include="HeuristicLab.snk" />
   </ItemGroup>