Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 5370)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 5371)
@@ -163,4 +163,5 @@
     }
     protected virtual void AddListViewItem(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       T item = (listViewItem.Tag as T);
       itemsListView.Items.Add(listViewItem);
@@ -174,4 +175,5 @@
     }
     protected virtual void InsertListViewItem(int index, ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       T item = (listViewItem.Tag as T);
       itemsListView.Items.Insert(index, listViewItem);
@@ -185,4 +187,5 @@
     }
     protected virtual void RemoveListViewItem(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       T item = (listViewItem.Tag as T);
       if (item != null) {
@@ -196,4 +199,5 @@
     }
     protected virtual void UpdateListViewItemImage(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       T item = listViewItem.Tag as T;
       int i = listViewItem.ImageIndex;
@@ -203,4 +207,5 @@
     }
     protected virtual void UpdateListViewItemText(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       T item = listViewItem.Tag as T;
       listViewItem.Text = item == null ? "null" : item.ToString();
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 5370)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 5371)
@@ -151,4 +151,5 @@
     }
     protected virtual void AddListViewItem(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       T item = (listViewItem.Tag as T);
       itemsListView.Items.Add(listViewItem);
@@ -164,4 +165,5 @@
     }
     protected virtual void RemoveListViewItem(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       T item = (listViewItem.Tag as T);
       if (item != null) {
@@ -177,4 +179,5 @@
     }
     protected virtual void UpdateListViewItemImage(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       T item = listViewItem.Tag as T;
       int i = listViewItem.ImageIndex;
@@ -184,4 +187,5 @@
     }
     protected virtual void UpdateListViewItemText(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       T item = listViewItem.Tag as T;
       listViewItem.Text = item == null ? "null" : item.ToString();
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 5370)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 5371)
@@ -166,4 +166,5 @@
     }
     protected virtual void AddListViewItem(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       T item = (listViewItem.Tag as T);
       itemsListView.Items.Add(listViewItem);
@@ -177,4 +178,5 @@
     }
     protected virtual void InsertListViewItem(int index, ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       T item = (listViewItem.Tag as T);
       itemsListView.Items.Insert(index, listViewItem);
@@ -188,4 +190,5 @@
     }
     protected virtual void RemoveListViewItem(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       T item = (listViewItem.Tag as T);
       if (item != null) {
@@ -199,4 +202,5 @@
     }
     protected virtual void UpdateListViewItemImage(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       T item = listViewItem.Tag as T;
       int i = listViewItem.ImageIndex;
@@ -206,4 +210,5 @@
     }
     protected virtual void UpdateListViewItemText(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       T item = listViewItem.Tag as T;
       listViewItem.Text = item == null ? "null" : item.ToString();
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs	(revision 5370)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs	(revision 5371)
@@ -175,4 +175,5 @@
     }
     private void AddListViewItem(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       itemsListView.Items.Add(listViewItem);
       IRun run = listViewItem.Tag as IRun;
@@ -186,4 +187,5 @@
     }
     private void RemoveListViewItem(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       IRun run = listViewItem.Tag as IRun;
       if (run != null) {
@@ -197,4 +199,5 @@
     }
     private void UpdateListViewItemImage(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       IRun item = listViewItem.Tag as IRun;
       int i = listViewItem.ImageIndex;
@@ -204,4 +207,5 @@
     }
     private void UpdateListViewItemText(ListViewItem listViewItem) {
+      if (listViewItem == null) throw new ArgumentNullException();
       IRun item = listViewItem.Tag as IRun;
       listViewItem.Text = item == null ? "null" : item.ToString();